
_interrupt:

;PIC DMX.c,39 :: 		void interrupt() {
;PIC DMX.c,41 :: 		USB_Interrupt_Proc();                   // USB servicing is done inside the interrupt
	CALL        _USB_Interrupt_Proc+0, 0
;PIC DMX.c,42 :: 		}
L_end_interrupt:
L__interrupt25:
	RETFIE      1
; end of _interrupt

_clear_USB_buffers:

;PIC DMX.c,44 :: 		void clear_USB_buffers()
;PIC DMX.c,46 :: 		for (i=0; i<63;i++)
	CLRF        _i+0 
L_clear_USB_buffers0:
	MOVLW       63
	SUBWF       _i+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_clear_USB_buffers1
;PIC DMX.c,48 :: 		readbuff[i] = 0;
	MOVLW       _readbuff+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_readbuff+0)
	MOVWF       FSR1H 
	MOVF        _i+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	CLRF        POSTINC1+0 
;PIC DMX.c,49 :: 		writebuff[i] = 0;
	MOVLW       _writebuff+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_writebuff+0)
	MOVWF       FSR1H 
	MOVF        _i+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	CLRF        POSTINC1+0 
;PIC DMX.c,46 :: 		for (i=0; i<63;i++)
	INCF        _i+0, 1 
;PIC DMX.c,50 :: 		}
	GOTO        L_clear_USB_buffers0
L_clear_USB_buffers1:
;PIC DMX.c,51 :: 		}
L_end_clear_USB_buffers:
	RETURN      0
; end of _clear_USB_buffers

_delay_4us:

;PIC DMX.c,53 :: 		void delay_4us()
;PIC DMX.c,55 :: 		asm{nop};
	NOP
;PIC DMX.c,56 :: 		asm{nop};
	NOP
;PIC DMX.c,57 :: 		asm{nop};
	NOP
;PIC DMX.c,58 :: 		asm{nop};
	NOP
;PIC DMX.c,59 :: 		asm{nop};
	NOP
;PIC DMX.c,60 :: 		asm{nop};
	NOP
;PIC DMX.c,61 :: 		asm{nop};
	NOP
;PIC DMX.c,62 :: 		asm{nop};
	NOP
;PIC DMX.c,63 :: 		asm{nop};
	NOP
;PIC DMX.c,64 :: 		asm{nop};
	NOP
;PIC DMX.c,65 :: 		asm{nop};
	NOP
;PIC DMX.c,66 :: 		asm{nop};
	NOP
;PIC DMX.c,67 :: 		asm{nop};
	NOP
;PIC DMX.c,68 :: 		asm{nop};
	NOP
;PIC DMX.c,69 :: 		asm{nop};
	NOP
;PIC DMX.c,70 :: 		asm{nop};
	NOP
;PIC DMX.c,71 :: 		asm{nop};
	NOP
;PIC DMX.c,72 :: 		asm{nop};
	NOP
;PIC DMX.c,73 :: 		asm{nop};
	NOP
;PIC DMX.c,74 :: 		asm{nop};
	NOP
;PIC DMX.c,75 :: 		asm{nop};
	NOP
;PIC DMX.c,76 :: 		asm{nop};
	NOP
;PIC DMX.c,77 :: 		asm{nop};
	NOP
;PIC DMX.c,78 :: 		asm{nop};
	NOP
;PIC DMX.c,79 :: 		asm{nop};
	NOP
;PIC DMX.c,80 :: 		asm{nop};
	NOP
;PIC DMX.c,81 :: 		asm{nop};
	NOP
;PIC DMX.c,82 :: 		asm{nop};
	NOP
;PIC DMX.c,83 :: 		asm{nop};
	NOP
;PIC DMX.c,84 :: 		asm{nop};
	NOP
;PIC DMX.c,85 :: 		asm{nop};
	NOP
;PIC DMX.c,86 :: 		asm{nop};
	NOP
;PIC DMX.c,87 :: 		asm{nop};
	NOP
;PIC DMX.c,88 :: 		asm{nop};
	NOP
;PIC DMX.c,89 :: 		asm{nop};
	NOP
;PIC DMX.c,90 :: 		asm{nop};
	NOP
;PIC DMX.c,91 :: 		asm{nop};
	NOP
;PIC DMX.c,92 :: 		asm{nop};
	NOP
;PIC DMX.c,93 :: 		asm{nop};
	NOP
;PIC DMX.c,94 :: 		asm{nop};
	NOP
;PIC DMX.c,95 :: 		}
L_end_delay_4us:
	RETURN      0
; end of _delay_4us

_write_headder:

;PIC DMX.c,97 :: 		void write_headder()
;PIC DMX.c,99 :: 		Tx  = 0;         //Break
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,100 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,101 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,102 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,103 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,104 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,105 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,106 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,107 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,108 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,109 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,110 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,111 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,112 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,113 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,114 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,115 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,116 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,117 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,118 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,119 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,120 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,121 :: 		Tx  = 1;          //MBB
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,122 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,123 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,124 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,125 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,126 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,127 :: 		}
L_end_write_headder:
	RETURN      0
; end of _write_headder

_write_byte:

;PIC DMX.c,129 :: 		void write_byte(char byte)
;PIC DMX.c,131 :: 		Tx = 0;       //Start Bit
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,132 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,133 :: 		if (byte.F0 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 0 
	GOTO        L_write_byte3
;PIC DMX.c,134 :: 		Tx = 0;       //Bit 0
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,135 :: 		}else {
	GOTO        L_write_byte4
L_write_byte3:
;PIC DMX.c,136 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,137 :: 		}
L_write_byte4:
;PIC DMX.c,138 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,139 :: 		if (byte.F1 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 1 
	GOTO        L_write_byte5
;PIC DMX.c,140 :: 		Tx = 0;       //bit 1
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,141 :: 		}else {
	GOTO        L_write_byte6
L_write_byte5:
;PIC DMX.c,142 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,143 :: 		}
L_write_byte6:
;PIC DMX.c,144 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,145 :: 		if (byte.F2 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 2 
	GOTO        L_write_byte7
;PIC DMX.c,146 :: 		Tx = 0;       //bit 2
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,147 :: 		}else {
	GOTO        L_write_byte8
L_write_byte7:
;PIC DMX.c,148 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,149 :: 		}
L_write_byte8:
;PIC DMX.c,150 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,151 :: 		if (byte.F3 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 3 
	GOTO        L_write_byte9
;PIC DMX.c,152 :: 		Tx = 0;       //bit 3
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,153 :: 		}else {
	GOTO        L_write_byte10
L_write_byte9:
;PIC DMX.c,154 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,155 :: 		}
L_write_byte10:
;PIC DMX.c,156 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,157 :: 		if (byte.F4 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 4 
	GOTO        L_write_byte11
;PIC DMX.c,158 :: 		Tx = 0;       //bit 4
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,159 :: 		}else {
	GOTO        L_write_byte12
L_write_byte11:
;PIC DMX.c,160 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,161 :: 		}
L_write_byte12:
;PIC DMX.c,162 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,163 :: 		if (byte.F5 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 5 
	GOTO        L_write_byte13
;PIC DMX.c,164 :: 		Tx = 0;       //bit 5
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,165 :: 		}else {
	GOTO        L_write_byte14
L_write_byte13:
;PIC DMX.c,166 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,167 :: 		}
L_write_byte14:
;PIC DMX.c,168 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,169 :: 		if (byte.F6 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 6 
	GOTO        L_write_byte15
;PIC DMX.c,170 :: 		Tx = 0;       //bit 6
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,171 :: 		}else {
	GOTO        L_write_byte16
L_write_byte15:
;PIC DMX.c,172 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,173 :: 		}
L_write_byte16:
;PIC DMX.c,174 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,175 :: 		if (byte.F7 == 0x00) {
	BTFSC       FARG_write_byte_byte+0, 7 
	GOTO        L_write_byte17
;PIC DMX.c,176 :: 		Tx = 0;       //bit 7
	BCF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,177 :: 		}else {
	GOTO        L_write_byte18
L_write_byte17:
;PIC DMX.c,178 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,179 :: 		}
L_write_byte18:
;PIC DMX.c,180 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,181 :: 		Tx = 1;
	BSF         RD6_bit+0, BitPos(RD6_bit+0) 
;PIC DMX.c,182 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,183 :: 		delay_4us();
	CALL        _delay_4us+0, 0
;PIC DMX.c,184 :: 		delay_4us();    //2 x stopp bits
	CALL        _delay_4us+0, 0
;PIC DMX.c,185 :: 		}
L_end_write_byte:
	RETURN      0
; end of _write_byte

_main:

;PIC DMX.c,187 :: 		void main(){
;PIC DMX.c,188 :: 		long cnt = 0;
	CLRF        main_cnt_L0+0 
	CLRF        main_cnt_L0+1 
	CLRF        main_cnt_L0+2 
	CLRF        main_cnt_L0+3 
;PIC DMX.c,190 :: 		ANCON0 = 0xFF;               // Default all pins to digital
	MOVLW       255
	MOVWF       ANCON0+0 
;PIC DMX.c,191 :: 		ANCON1 = 0x1F;
	MOVLW       31
	MOVWF       ANCON1+0 
;PIC DMX.c,192 :: 		TRISD = 0;
	CLRF        TRISD+0 
;PIC DMX.c,193 :: 		TRISC = 0;
	CLRF        TRISC+0 
;PIC DMX.c,194 :: 		TRISB = 0;
	CLRF        TRISB+0 
;PIC DMX.c,195 :: 		TRISA = 0;
	CLRF        TRISA+0 
;PIC DMX.c,196 :: 		RCSTA1=1;
	MOVLW       1
	MOVWF       RCSTA1+0 
;PIC DMX.c,198 :: 		T1_Direction = 1;         // Set direction for buttons
	BSF         TRISD3_bit+0, BitPos(TRISD3_bit+0) 
;PIC DMX.c,199 :: 		T2_Direction = 1;
	BSF         TRISD2_bit+0, BitPos(TRISD2_bit+0) 
;PIC DMX.c,201 :: 		LD1_Direction = 0;        // Set direction for LEDS
	BCF         TRISA0_bit+0, BitPos(TRISA0_bit+0) 
;PIC DMX.c,202 :: 		LD2_Direction = 0;
	BCF         TRISA1_bit+0, BitPos(TRISA1_bit+0) 
;PIC DMX.c,203 :: 		LD1 = 0;                  // turn off leds
	BCF         LATA0_bit+0, BitPos(LATA0_bit+0) 
;PIC DMX.c,204 :: 		LD2 = 0;
	BCF         LATA1_bit+0, BitPos(LATA1_bit+0) 
;PIC DMX.c,206 :: 		RW = 0; //RS485 Read
	BCF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;PIC DMX.c,207 :: 		RW_Direction = 0; // Output
	BCF         TRISC6_bit+0, BitPos(TRISC6_bit+0) 
;PIC DMX.c,208 :: 		Tx_Direction = 0; //Output
	BCF         TRISD6_bit+0, BitPos(TRISD6_bit+0) 
;PIC DMX.c,210 :: 		clear_USB_buffers();
	CALL        _clear_USB_buffers+0, 0
;PIC DMX.c,212 :: 		Delay_ms(100);
	MOVLW       7
	MOVWF       R11, 0
	MOVLW       23
	MOVWF       R12, 0
	MOVLW       106
	MOVWF       R13, 0
L_main19:
	DECFSZ      R13, 1, 1
	BRA         L_main19
	DECFSZ      R12, 1, 1
	BRA         L_main19
	DECFSZ      R11, 1, 1
	BRA         L_main19
	NOP
;PIC DMX.c,214 :: 		HID_Enable(&readbuff,&writebuff);       // Enable HID communication
	MOVLW       _readbuff+0
	MOVWF       FARG_HID_Enable_readbuff+0 
	MOVLW       hi_addr(_readbuff+0)
	MOVWF       FARG_HID_Enable_readbuff+1 
	MOVLW       _writebuff+0
	MOVWF       FARG_HID_Enable_writebuff+0 
	MOVLW       hi_addr(_writebuff+0)
	MOVWF       FARG_HID_Enable_writebuff+1 
	CALL        _HID_Enable+0, 0
;PIC DMX.c,216 :: 		while (1){
L_main20:
;PIC DMX.c,217 :: 		cnt++;
	MOVLW       1
	ADDWF       main_cnt_L0+0, 1 
	MOVLW       0
	ADDWFC      main_cnt_L0+1, 1 
	ADDWFC      main_cnt_L0+2, 1 
	ADDWFC      main_cnt_L0+3, 1 
;PIC DMX.c,219 :: 		if (cnt > 5000) {
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       main_cnt_L0+3, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main31
	MOVF        main_cnt_L0+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main31
	MOVF        main_cnt_L0+1, 0 
	SUBLW       19
	BTFSS       STATUS+0, 2 
	GOTO        L__main31
	MOVF        main_cnt_L0+0, 0 
	SUBLW       136
L__main31:
	BTFSC       STATUS+0, 0 
	GOTO        L_main22
;PIC DMX.c,221 :: 		LD1 = ~LD1;      //Toggle LED 1
	BTG         LATA0_bit+0, BitPos(LATA0_bit+0) 
;PIC DMX.c,223 :: 		cnt = 0;         //Reset Counter
	CLRF        main_cnt_L0+0 
	CLRF        main_cnt_L0+1 
	CLRF        main_cnt_L0+2 
	CLRF        main_cnt_L0+3 
;PIC DMX.c,224 :: 		GIE_bit = 0;                         // Disable all interrupts
	BCF         GIE_bit+0, BitPos(GIE_bit+0) 
;PIC DMX.c,226 :: 		RW = 1;     //Write
	BSF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;PIC DMX.c,227 :: 		write_headder();
	CALL        _write_headder+0, 0
;PIC DMX.c,228 :: 		write_byte(readbuff[0]);  //Should be 0x00
	MOVF        1280, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,229 :: 		write_byte(readbuff[1]);
	MOVF        1281, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,230 :: 		write_byte(readbuff[2]);
	MOVF        1282, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,231 :: 		write_byte(readbuff[3]);
	MOVF        1283, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,232 :: 		write_byte(readbuff[4]);
	MOVF        1284, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,233 :: 		write_byte(readbuff[5]);
	MOVF        1285, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,234 :: 		write_byte(readbuff[6]);
	MOVF        1286, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,235 :: 		write_byte(readbuff[7]);
	MOVF        1287, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,236 :: 		write_byte(readbuff[8]);
	MOVF        1288, 0 
	MOVWF       FARG_write_byte_byte+0 
	CALL        _write_byte+0, 0
;PIC DMX.c,237 :: 		RW = 0; //RS485 hiZ
	BCF         LATC6_bit+0, BitPos(LATC6_bit+0) 
;PIC DMX.c,238 :: 		GIE_bit = 1;                         // enable all interrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;PIC DMX.c,239 :: 		}
L_main22:
;PIC DMX.c,242 :: 		kk = HID_Read();
	CALL        _HID_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _kk+0 
;PIC DMX.c,243 :: 		if (kk != 0)
	MOVF        R0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main23
;PIC DMX.c,245 :: 		HID_Write(&readbuff,64);
	MOVLW       _readbuff+0
	MOVWF       FARG_HID_Write_writebuff+0 
	MOVLW       hi_addr(_readbuff+0)
	MOVWF       FARG_HID_Write_writebuff+1 
	MOVLW       64
	MOVWF       FARG_HID_Write_len+0 
	CALL        _HID_Write+0, 0
;PIC DMX.c,246 :: 		}
L_main23:
;PIC DMX.c,248 :: 		}
	GOTO        L_main20
;PIC DMX.c,249 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
