#line 1 "C:/Users/Carl/Documents/Pic Projects/Pic18/Pic DMX/PIC DMX.c"
#line 14 "C:/Users/Carl/Documents/Pic Projects/Pic18/Pic DMX/PIC DMX.c"
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;

char cnt;
char kk;
char i,j;


sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

sbit RW at LATC6_bit;
sbit RW_Direction at TRISC6_bit;

sbit Tx at RD6_bit;
sbit Tx_Direction at TRISD6_bit;


void interrupt() {

 USB_Interrupt_Proc();
}

void clear_USB_buffers()
{
 for (i=0; i<63;i++)
 {
 readbuff[i] = 0;
 writebuff[i] = 0;
 }
}

void delay_4us()
{
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
}

void write_headder()
{
 Tx = 0;
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 Tx = 1;
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
}

void write_byte(char byte)
{
 Tx = 0;
 delay_4us();
 if (byte.F0 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F1 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F2 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F3 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F4 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F5 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F6 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 if (byte.F7 == 0x00) {
 Tx = 0;
 }else {
 Tx = 1;
 }
 delay_4us();
 Tx = 1;
 delay_4us();
 delay_4us();
 delay_4us();
}

void main(){
 long cnt = 0;

 ANCON0 = 0xFF;
 ANCON1 = 0x1F;
 TRISD = 0;
 TRISC = 0;
 TRISB = 0;
 TRISA = 0;
 RCSTA1=1;

 T1_Direction = 1;
 T2_Direction = 1;

 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 RW = 0;
 RW_Direction = 0;
 Tx_Direction = 0;

 clear_USB_buffers();

 Delay_ms(100);

 HID_Enable(&readbuff,&writebuff);

 while (1){
 cnt++;

 if (cnt > 5000) {

 LD1 = ~LD1;

 cnt = 0;
 GIE_bit = 0;

 RW = 1;
 write_headder();
 write_byte(readbuff[0]);
 write_byte(readbuff[1]);
 write_byte(readbuff[2]);
 write_byte(readbuff[3]);
 write_byte(readbuff[4]);
 write_byte(readbuff[5]);
 write_byte(readbuff[6]);
 write_byte(readbuff[7]);
 write_byte(readbuff[8]);
 RW = 0;
 GIE_bit = 1;
 }


 kk = HID_Read();
 if (kk != 0)
 {
 HID_Write(&readbuff,64);
 }

 }
}
